#ifndef OPTIONS_H
#define OPTIONS_H


typedef enum _OPTION_RESULT_
{
    OPTION_INVALID_PARAMS,
    OPTION_INVALID_OPTION,
    OPTION_OK,
    OPTION_FAILED,
    OPTION_NOT_EXIST_DEVICE,
    OPTION_ERROR_DEVICE_ID,
} OPTION_RESULT;

typedef enum _OPTION_CMD_
{
    OPTION_CMD_USAGE,
    OPTION_CMD_LIST,

    OPTION_CMD_OSD_PNG,
    OPTION_CMD_OSD_VIDEO,

} OPTION_CMD;

extern unsigned int g_dwCMD;


OPTION_RESULT ParseCommandLine(int argc, char *argv[]);
OPTION_RESULT ParseDeviceArgument(char *szArg);


void PrintUsage();

#endif // OPTIONS_H
