#include <stdio.h>
#include "setting.h"

static void sdkTest()
{

     int nRet = Init();
     if (nRet != 0)
     {
         return;
     }

    //channel
     testMWGetVersion();
     testMWCaptureInitInstance();
     testMWCaptureExitInstance();
     testMWRefreshDevice();
     testMWGetChannelCount();
     testMWGetChannelInfoByIndex();
     testMWGetFamilyInfoByIndex();
     testMWGetDevicePath();
     testMWOpenChannel();
     testMWOpenChannelByPath();
     testMWCloseChannel();
     testMWGetChannelInfo();
     testMWGetFamilyInfo();
     testMWGetVideoCaps();
     testMWGetAudioCaps();
     testMWGetVideoInputSourceArray();
     testMWGetAudioInputSourceArray();
     testMWGetInputSourceScan();
     testMWSetInputSourceScan();
     testMWGetAVInputSourceLink();
     testMWSetAVInputSourceLink();
     testMWGetVideoInputSource();
     testMWSetVideoInputSource();
     testMWGetAudioInputSource();
     testMWSetAudioInputSource();

     //edid
     testMWGetEDID();
     testMWSetEDID();

     //    signal status
     testMWGetInputSpecificStatus();
     testMWGetVideoSignalStatus();
     testMWGetAudioSignalStatus();

     //    hdmi infoframe
     testMWGetHDMIInfoFrameValidFlag();
     testMWGetHDMIInfoFramePacket();

     //device time
     testMWGetDeviceTime();
     testMWSetDeviceTime();
     testMWRegulateDeviceTime();

     //timer event
     testMWRegisterTimer();
     testMWUnregisterTimer();
     testMWScheduleTimer();
     //notify event
     testMWRegisterNotify();
     testMWUnregisterNotify();
     testMWGetNotifyStatus();

     //video capture
     testMWStartVideoCapture();
     testMWStopVideoCapture();
     testMWPinVideoBuffer();
     testMWUnpinVideoBuffer();
     //     testMWCaptureVideoFrameToVirtualAddress();
     //     testMWCaptureVideoFrameToPhysicalAddress();//NULL
     //     testMWCaptureVideoFrameWithOSDToVirtualAddress();//NULL
     //     testMWCaptureVideoFrameWithOSDToPhysicalAddress();//NULL
     //     testMWCaptureVideoFrameToVirtualAddressEx();//NULL
     //     testMWCaptureVideoFrameToPhysicalAddressEx();//NULL
     testMWGetVideoBufferInfo();
     testMWGetVideoFrameInfo();
     //     testMWGetVideoCaptureStatus();//NULL

     //audio capture
     testMWStartAudioCapture();
     testMWStopAudioCapture();
     testMWCaptureAudioFrame();

     //video processing
     testMWGetVideoInputAspectRatio();
     testMWSetVideoInputAspectRatio();
     testMWGetVideoInputColorFormat();
     testMWSetVideoInputColorFormat();
     testMWGetVideoInputQuantizationRange();
     testMWSetVideoInputQuantizationRange();
     //led
     testMWSetLEDMode();

     //upgrade firmware
     testMWGetFirmwareStorageInfo();
     //     testMWEraseFirmwareData();//NULL
     testMWReadFirmwareData();
     //     testMWWriteFirmwareData();//NULL
     testMWSetPostReconfig();

     //osd
     testMWCreateImage();
     testMWOpenImage();
     testMWCloseImage();
     //     testMWUploadImageFromVirtualAddress();//NULL
     //     testMWUploadImageFromPhysicalAddress();//NULL

     //temperature
     testMWGetTemperature();

     //  v4l2
     testMWGetStreamCount();
     testMWGetStreamInfos();
     testMWSetCtrlStreamID();
     testMWGetVideoConnectFormat();
     testMWGetVideoProcessSettings();
     testMWSetVideoProcessSettings();
     testMWGetVideoOSDSettings();
     testMWSetVideoOSDSettings();
     testMWGetVideoOSDImage();
     testMWSetVideoOSDImage();
     testMWGetVideoBrightness();
     testMWSetVideoBrightness();
     testMWGetVideoContrast();
     testMWSetVideoContrast();
     testMWGetVideoHue();
     testMWSetVideoHue();
     testMWGetVideoSaturation();
     testMWSetVideoSaturation();

    // VGA/Component timings
     testMWGetVideoAutoHAlign();
     testMWSetVideoAutoHAlign();
     testMWGetVideoSamplingPhase();
     testMWSetVideoSamplingPhase();
     testMWGetVideoSamplingPhaseAutoAdjust();
     testMWSetVideoSamplingPhaseAutoAdjust();
     testMWSetVideoTiming();
     testMWGetVideoPreferredTimingArray();
     testMWSetCustomVideoTiming();
     testMWGetCustomVideoTimingsCount();
     testMWGetCustomVideoTimingsArray();
     testMWSetCustomVideoTimingsArray();
     testMWGetCustomVideoResolutionsCount();
     testMWGetCustomVideoResolutionsArray();
     testMWSetCustomVideoResolutionsArray();

//    //event
     testMWCreateEvent();
     testMWCloseEvent();
     testMWSetEvent();
     testMWClearEvent();
     testMWIsSetEvent();
     testMWTryWaitEvent();
     testMWWaitEvent();
     testMWMultiWaitEvent();

//     testMWOpenImage();

     closeChannel();

     return;
}


int main(int argc, char **argv)
{
    sdkTest();

    return 0;
}


