#ifndef CVIDEOWIDGET_H
#define CVIDEOWIDGET_H
#include <QObject>
#include <QWidget>
#include <QDebug>
#include "publicheader.h"
//#include "videorenderxcb.h"
class CVideoWidget : public QWidget
{
    Q_OBJECT
public:
    explicit CVideoWidget(QWidget *parent = 0);
    ~CVideoWidget();

    // get the subWindow hWnd
    VideoRenderXCB *GetRender()
    {
        return  m_VideoRender;
    }

    VideoRenderImageBuf *GetFrameBuffer()
    {
        return NULL;
        //return m_pVideoBuffer;
    }

    bool CreateRender();
    void DestoryRender();

    void CreateLayout();
    void ResetBuffer(int nWidth, int nHeight);
    //void DisplayFrame(VideoRenderImageBuf *pVideouffer);
    void DisplayFrame(void *buffer, size_t size);
    DWORD GetCaptureFourcc()
    {
        //return 0;
        return m_dwFourcc;
    }

protected:
    bool SupportFourcc(unsigned int *dwFourcc);

protected:
    QWidget                 *m_wndSubWidget;
    DWORD                   m_dwFourcc;

    //render
    VideoRenderXCB          *m_VideoRender;
    VideoRenderImageBuf     *m_pVideoBuffer;
};

#endif // CVIDEOWIDGET_H
