#ifndef CDLGAMPPROC_H
#define CDLGAMPPROC_H

#include <QWidget>
#include "publicheaders.h"
#include "cvideochannel.h"
#include "cgenerateshfile.h"


class CDlgAmpproc : public QWidget
{
    Q_OBJECT
public:
    explicit CDlgAmpproc(QWidget *parent = 0);


protected:
    QSlider*        m_sldBrightness;
    QSlider*        m_sldHue;
    QSlider*        m_sldSaturation;
    QSlider*        m_sldContract;
    QLineEdit*          m_editBrightness;
    QLineEdit*          m_editHue;
    QLineEdit*          m_editSaturation;
    QLineEdit*          m_editContract;
    QPushButton*        m_btnDefault;

    CGenerateSHFile     *m_shFile;

    //config
    int             m_nBrightness;
    int             m_nHue;
    int             m_nSaturation;
    int             m_nContract;

signals:

public slots:
    void onBrightnessValueChanged(int nValue);
    void onHueValueChanged(int nValue);
    void onSaturationValueChanged(int nValue);
    void onContractValueChanged(int nValue);
    void onBtnDefaultClicked();

};

#endif // CDLGAMPPROC_H
