#include <QApplication>
#include <QFile>
#include "widget.h"


int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QFile file(":/qss/lowlatency.qss");
    file.open(QFile::ReadOnly);
    QString strStylySheet = QLatin1String(file.readAll());
    a.setStyleSheet(strStylySheet);
    file.close();

    MWCapture::Init();
    MWCapture::RefreshDevices();

    Widget w;
    w.show();

    return a.exec();
}
