#include "aboutdlg.h"

CAboutDlg::CAboutDlg(QWidget *parent)
    : QDialog(parent)
{
    setWindowTitle(tr("About"));
    setMinimumSize(250,100);
    //Left
    m_imgImage.load(":/image/videos_64px.png");
    m_labImage = new QLabel;
    m_labImage->setPixmap(QPixmap::fromImage(m_imgImage));
    m_vblLeft = new QVBoxLayout;
    m_vblLeft->addWidget(m_labImage);
    //Right
    m_labProName = new QLabel;
    m_labProName->setAlignment(Qt::AlignCenter);
    m_labProName->setText(tr("mwcap-multiview   "));
    m_labVer = new QLabel;
    m_labVer->setAlignment(Qt::AlignCenter);
    m_labVer->setText(tr("version: v1.0  "));
    m_vblRight = new QVBoxLayout;
    m_vblRight->setAlignment(Qt::AlignCenter);
    m_vblRight->addWidget(m_labProName);
    m_vblRight->addWidget(m_labVer);
    //Main
    m_hblMain = new QHBoxLayout;
    m_hblMain->addLayout(m_vblLeft);
    m_hblMain->addLayout(m_vblRight);
    setLayout(m_hblMain);
}

CAboutDlg::~CAboutDlg()
{

}

