#include "mainwindow.h"
#include <QApplication>
#include "mwcapture.h"
#include "mainview.h"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    a.setWindowIcon(QIcon(":/image/videos_72px.ico"));

    QFile file(":/qss/multiview.qss");
    file.open(QFile::ReadOnly);
    QString strStylySheet = QLatin1String(file.readAll());
    a.setStyleSheet(strStylySheet);
    file.close();

    MWCapture::Init();
    MWCapture::RefreshDevices();

    MainWindow w;
    w.show();

    return a.exec();
}
