#ifndef PUBLICHEADER
#define PUBLICHEADER
#include "videorenderxcb.h"

#ifdef __cplusplus
extern "C"{
#include "lib-mw-capture.h"
}
#endif

class ICaptureCallback
{
public:
    //virtual void OnCaptureCallback(VideoRenderImageBuf *pBuffer) = 0;
    virtual void OnCaptureCallback(MWCAP_PTR buffer, size_t size) = 0;
    virtual void OnSnapshotCallback(unsigned char *pImage) = 0;
};

enum {CLOSE_FULLSCREEN = 0, OPEN_FULLSCREEN};

typedef enum{
    RET_FALSE = 0,
    RET_TRUE
}RET_RES;

typedef struct _IMAGEYUVDATA_TAG
{
    int             cx;
    int             cy;
    BYTE            *pYUY2Address;
}ImageYuvData;

typedef struct _STATUS_RET_TAG
{
    int                         cx;
    int                         cy;
    MWCAP_VIDEO_SIGNAL_STATUS   pVideo;
    MWCAP_AUDIO_SIGNAL_STATUS   pAudio;
}StatusRet;

#endif // PUBLICHEADER

